<template>
  <div id="app">
    <v-app>
      <v-app-bar app>
        <label for="services">Choose a Service</label>
        <v-row justify="center" class="ma-2">
          <v-col sm="6">
            <v-select v-bind:items="serviceList" v-model="selectedService" v-on:change="serviceChanged"/>
          </v-col>
        </v-row>
      </v-app-bar>
      <v-navigation-drawer app width="300">
        <DataTable />
      </v-navigation-drawer>
      <v-main> 
        <div  v-for="service in serviceList" v-bind:key="service">
        <v-container  v-bind:id="service"  v-bind:style="{display:serviceVisibility[service]}"> 
            <v-row v-for="component  of components2create" v-bind:key="component.compParam.url_request_path">
            <v-col >
              <div v-bind:id="createComponentIndex(component,service)" ></div>                
            </v-col>
          </v-row>  
        </v-container>
      </div>
      </v-main>
    </v-app>
  </div>
</template>

<script>
import DataTable from "./components/DataTable.vue";
import Vue from "vue";
import ElarStattimeSlider from "./components/ElarStatTimeSlider.vue";
const ElarStattimeSliderCtor = Vue.extend(ElarStattimeSlider);
import ElarStat2ndComp from "./components/ElarStat2ndComp.vue";
const ElarStat2ndCompCtor = Vue.extend(ElarStat2ndComp);
import {useGlobalStore} from './stores/globalStore.js';



export default {
  setup() {  
    let globalStore = useGlobalStore();
    return {globalStore}
  },
  name: "App",
  components: {
    DataTable: DataTable  
  },
  data() {
    return {
      serviceVisibility:{},
      createdComponents: [],
      selectedService: null,
      title: null,
      service2Choose: {
        Paritetici: {
          title: "Servizio contributo paritetici",
          A42: 35,
        },
        Rendite: {
          title: "Rendite",
          A42: 11,
        },
        AssegniFamiliari: {
          title: "Assegni Familiari",
          A42: 55,
        },
      },
      components2create: [
        {
          compType: "ElarStatTimeSlider",
          compParam: {          
            url_request_path: "nbr_prat_per_date_and_da_spec",
            column4trace_title: "Z_2BEZ",
            plotly_title: "Numero di Pratiche per processo",
            plotly_type: "line",
            column4trace_param: "A43",
            x_column: "MY_DATE",
            y_column: "NBR_QUERIES",
          },
        },
        {
          compType: "ElarStat2ndComp",
          compParam: {            
            url_request_path: "nbr_op_per_coll_and_da_spec_param_date",
            column4trace_title: "Z_2BEZ",
            plotly_title: "Numero di operazione per processo e collaboratore",
            plotly_type: "bar",
            column4trace_param: "A43",
            x_column: "B_NAME",
            y_column: "NBR_QUERIES",
          },
        },
        {
          compType: "ElarStat2ndComp",
          compParam: {   
            url_request_path: "nbr_op_per_da_spec_and_doc_type_param_date",
            column4trace_title: "Z_2BEZ",
            plotly_title: "Numero di operazione per processo e tipo di documento",
            plotly_type: "bar",
            column4trace_param: "A43",
            x_column: "DOC_TYPE",
            y_column: "NBR_QUERIES",
          },
        },
      ],
    };
  },
  created() {
    for (const service of this.serviceList) {
      this.serviceVisibility[service] = 'none';
    }
  },
  computed: {
    serviceList: function () {
      return Object.keys(this.service2Choose);
    },
  },
  methods: { 
    createComponentIndex(component, service) {
      return component.compParam.url_request_path + "-" + service;
    },
    createComponents(service) {
      let serviceParam =  this.service2Choose[service];      
      for (let component of this.components2create) {
        let compIndex = this.createComponentIndex(component,service);
        if (this.createdComponents.includes(compIndex)) {         
          continue;
        }     
        console.log("-----component to create =",component);
        let allParameters = { ...serviceParam, ...component };
        if (component.compType === "ElarStatTimeSlider") { 
          const ElarStattimeSliderInstance = new ElarStattimeSliderCtor({ propsData: allParameters });
          let mountResult = ElarStattimeSliderInstance.$mount("#" + compIndex);
          console.log("------mountResult=",mountResult);
          this.createdComponents.push(compIndex);
        } else if (component.compType === "ElarStat2ndComp")  {
          let componentInstance = new ElarStat2ndCompCtor({ propsData: allParameters });
          componentInstance.$mount("#" + compIndex);
          this.createdComponents.push(compIndex);
        } 
      }
    },
    /**
     * This methods reacts to the change of the service in the ServiceList
     */
    serviceChanged() {     
      for (const service in this.serviceVisibility) {
        this.serviceVisibility[service] = 'none';       
      }   
      this.globalStore.selectedService=this.selectedService;
      this.serviceVisibility[this.selectedService] = 'block';   
      console.log("-----selected service = ", this.selectedService);
      console.log("----serviceChanged--serviceVisibility=",this.serviceVisibility);   
      this.createComponents(this.selectedService);  
    
      /*    
      document.getElementById("component1").appendChild(component.$el)
      ElarStattimeSliderInstance.$mount( + this.selectedService);
      */      
    }
  },
};
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: black;
  text-align: left;
  color: #2c3e50;
  margin-top: 0px;
}
</style>
